--[[
wav hex opener
by sam (youresam)
]]--

--------------------
--this can be 1 or 2, shows patterns based on different bytes
loop = 2
--------------------



if loop == 1 then
	add = 0
	divide_by = 1
elseif loop == 2 then
	add = 1
	divide_by = 100
end

file = io.open("wave.wav", "rb")
if file then
filestring = file:read("*all")
file:close()
end

function b(byte_number, byte_length)
bytes = ""
for a=byte_number + 1, byte_number +byte_length do
	temp_bytes = dec_to_hex(string.byte(string.sub(filestring, a, a)))
	if string.len(temp_bytes) ~= 2 then
		temp_bytes = "0" .. temp_bytes
	end
	bytes = bytes .. temp_bytes
end

return hex_to_dec(bytes)
end

--[[

]]--


hex_values = {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", "E", "F" }
function dec_to_hex(hexvalue)
count = 0
power = 6
number = hexvalue
total = 0
totals = {0,0,0,0,0,0,0}
while number ~= 0 do
count = count + 1
	if math.floor(number / (16^power)) >= 1 then
		totals[power+1] = totals[power+1] + 1
		number = number - (16^power)
	else
		power = power - 1
	end
end

for a=1, table.getn(totals) do
total = total + (totals[a] * (10^a / 10))
end

return total

end


function hex_to_dec(hexvalue)
len = string.len(hexvalue)
		newvalue = ""
	while string.len(hexvalue) ~= 0 do --flip hex based on 2
		newvalue = newvalue .. string.sub(hexvalue, string.len(hexvalue)-1, string.len(hexvalue))
		hexvalue = string.sub(hexvalue, 1, string.len(hexvalue)-2)
	end
count = 0
completevalue = 0

	for a=len, 1, -1 do --start at end, and go back 1 by 1
		count = count + 1
			for b=1, table.getn(hex_values) do --use table to find out value of hex char
				if string.sub(newvalue, a, a) == hex_values[b] then 
				hexcountvalue = b-1 
				--print(string.sub(newvalue, a, a) .. " = " .. b-1)
				end
			end
	completevalue = completevalue + (hexcountvalue * (16^(count - 1)) )
	end
return completevalue
end

--fake print
fakeprint_line = 0
function fakeprint(fakeprint_text)
screen:print(0,fakeprint_line, fakeprint_text,Color.new(255,255,255))
fakeprint_line = fakeprint_line + 8
end

screen:clear()
-----
fakeprint("ChunkSize = "..b(4,4))
fakeprint("Subchunk1ID = "..b(12,4))
fakeprint("Subchunk1Size = "..b(16, 4))
if b(20, 2) == 1 then fakeprint("AudioFormat = PCM") end
fakeprint("NumChannels = "..b(22,2))
fakeprint("SampleRate = "..b(24, 4))
fakeprint("ByteRate = "..b(28,4))
fakeprint("BlockAlign = "..b(32,2))
fakeprint("BitsPerSample = "..b(34,2))
fakeprint("Subchunk2Size = "..b(40,4))
fakeprint("")
-----
screen.flip()
screen:clear()

num_samples = string.len(string.sub(filestring,59)) /2

total_time = num_samples / (b(24, 4) / 1000)

remove_interval = math.ceil(num_samples/480)
samples = {}

screen.flip()
fakeprint("Calculating waves...")
screen.flip()

for a=1, num_samples, remove_interval do
table.insert(samples,b(58+(a*2)-2+ add, 1))
--screen.waitVblankStart()
end

screen.flip()
fakeprint("Done, press X to continue...")
screen.flip()

while not Controls.read():cross() do screen.waitVblankStart() end

waves = Image.createEmpty(480,272)
waves:clear(Color.new(0,0,0))

oldpoint = 0
count = 0
for a=1, table.getn(samples) do
newpoint = samples[a]/ divide_by
waves:drawLine(count-1, oldpoint, count, newpoint, Color.new(255,255,255))
oldpoint = newpoint
count = count + 1
end

line = 0
sound1 =  Sound.load("wave.wav", false)
sound1timer = Timer.new()
sound1timer:reset(0)

function playsound()
line = 0
sound1timer:reset(0)
sound1controller = sound1:play()
sound1timer:start()
end

playsound() --quick fix to make the while loop simple, sound1controller:stop() can only
            --be ran if it has played a sound before

while true do 
input = Controls.read()
	if input:cross() then
		sound1controller:stop()
		while Controls.read():cross() do screen.waitVblankStart() end
		playsound()
	end
line = sound1timer:time()*(480/total_time) --line position
screen:blit(0,0,waves) --no need to clear the screen since its BG is black
screen:drawLine(line, 0, line, 271, Color.new(255,0,0))
screen.waitVblankStart()
screen.flip()
if input:start() then break end
if sound1timer:time() >= total_time then sound1timer:reset(0) end
end

